unit hiBASS_WinampVisPlugin;

interface

uses Kol,windows,Share,Debug,bass;

type
  PWinampVisModule =^TWinampVisModule;
  TWinampVisModule = record
    description: PChar; // 
    hwndParent: HWND; //  (  , .. Winamp,    0)
    hDllInstance: HINST; // DLL ( Winamp-,     0)
    sRate, //  ( Winamp-)
    nCh, //  ( Winamp-)
    latencyMs, //  (Winamp      )
    delayMs, //         Nch 
    spectrumNch, //     
    waveformNch: Integer; //      
    spectrumData: array [0..1, 0..575] of Byte; // 
    waveformData: array [0..1, 0..575] of Byte; //  
    Config: procedure(this_mod:PwinampVisModule); cdecl;//   (       "Configure")
    Init:function(this_mod:PwinampVisModule):Integer; cdecl;//,  0   
    Render: function(this_mod:PwinampVisModule):Integer; cdecl;//,      ( 0   , 1 -   )
    Quit: procedure(this_mod:PwinampVisModule); cdecl;//   
    userData: Pointer; //  (  )
  end;

type
  PwinampVisHeader =^TwinampVisHeader;
  TwinampVisHeader = record
    version: Integer; //   ($101 = 1.01)
    description: Pchar; // 
    getModule:function(i:Integer):PWinampVisModule;cdecl; //   Winamp  PwinampVisModule
  end;

type
  THIBASS_WinampVisPlugin = class(TDebug)
   private
   public
    FTimer:PTimer;
    _prop_Channel:^cardinal;
    _data_hwd:THI_Event;

    _event_onLoad:THI_Event;


    procedure _work_doLoadVisPlugin(var _Data:TData; Index:word);
    procedure _work_doUnLoadVisPlugin(var _Data:TData; Index:word);
    procedure _work_doConfig(var _Data:TData; Index:word);
    procedure _var_Info(var _Data:TData; Index:word);
    procedure Rendering(Obj:PObj);
  end;

type TwinampVisGetHeader = function :PwinampVisHeader;

implementation

var winampVisGetHeader:TwinampVisGetHeader;
    VisHeader: PwinampVisHeader;
    VisModule: PWinampVisModule;
    plug: THandle;

procedure THIBASS_WinampVisPlugin.Rendering;
var
  i,j: integer;
  level: DWord;
  levelL, levelR: byte;
  h:cardinal;
begin
  if BASS_ChannelIsActive(_prop_Channel^) <> BASS_ACTIVE_PLAYING then Exit;
  if plug = 0 then exit;
  for i:=0 to 1 do
  for j:=0 to 575 do
    begin
      level := BASS_ChannelGetLevel(_prop_Channel^);
      levelL := loword(level) * 100 div (maxword div 2);
      levelR := hiword(level) * 100 div (maxword div 2);
      VisModule.spectrumData[i,j]:=levelL*2;
      VisModule.waveformData[i,j]:=levelR*2;
    end;
  VisModule.Render(VisModule);
end;

procedure THIBASS_WinampVisPlugin._work_doLoadVisPlugin;
var pl: string;
    h: integer;
begin
  pl := ToString(_Data);
  plug:=LoadLibrary(PChar(pl));
  winampVisGetHeader:=GetProcAddress(plug,'winampVisGetHeader');
  h := ReadInteger(_Data,_data_hwd);
  if @winampVisGetHeader=nil then exit;
  VisHeader:=winampVisGetHeader;
  if VisHeader=nil then exit;
  VisModule:=VisHeader.getModule(0);
  VisModule.hwndParent:=h;
  VisModule.nCh:=2;
  VisModule.hDllInstance:=plug;
  VisModule.sRate:=44100;
  if VisModule.Init(VisModule)<>0 then exit;
  FTimer := NewTimer(100);
  FTimer.Enabled := true;
  FTimer.OnTimer := Rendering;
  _hi_OnEvent(_event_onLoad,'');
end;


procedure THIBASS_WinampVisPlugin._work_doUnLoadVisPlugin;
begin
  if plug = 0 then exit;
  FTimer.Enabled := False;
  FTimer.Free;
  VisModule.Quit(VisModule);
  FreeLibrary(plug);
  plug := 0;
end;

procedure THIBASS_WinampVisPlugin._work_doConfig;
begin
  VisModule.Config(VisModule);
end;

procedure THIBASS_WinampVisPlugin._var_Info;
begin
  dtString(_Data, VisHeader.description + ';' + VisModule.description);
end;

end.
